/*
** Module   :ESTOP.CPP
** Abstract :Main module
**
** Copyright (C) Sergey I. Yevtushenko
** Log: Sun  01/06/97   Created from stripped down PM version
*/

#define INCL_DOS
#include <os2.h>
#include <stdio.h>
#include <stdlib.h>
#include <pscoll.h>

ProcessCollection pcList;

char *pcProcColor[]=
{
   "0;37","1;32","1;33","1;31"
};

#define NUM_COLORS (sizeof(pcProcColor)/sizeof(pcProcColor[0]))

char usage[]=
"ESTOP  V0.0.2 Copyright (C) Sergey I. Yevtushenko 1997\n"
"Per process CPU usage display utility.\n"
"\tUsage: estop [-i<seconds>] [-l<lines>]\n"
;


int main(int argc, char **argv)
{
    int NUM_LINES = 22;
    int INTERVAL  = 1;

    for(int n = 1; n < argc; n++)
    {
        if(argv[n][0]=='-' || argv[n][0]=='-')
            switch(argv[n][1])
            {
                case '?':
                case 'h':
                case 'H':
                    printf(usage);
                    return -1;

                    break;
                case 'l':
                case 'L':
                    NUM_LINES = atoi(&argv[n][2]) - 3;
                    if(NUM_LINES <= 0)
                        NUM_LINES = 22;
                    break;

                case 'i':
                case 'I':
                    INTERVAL = atoi(&argv[n][2]);
                    if(INTERVAL <= 0)
                        INTERVAL = 1;
            }
    }

    printf("\x1b[2J");
    for(;;)
    {
        pcList.CollectData();

        printf("\x1b[40m\x1b[0;37m\x1b[1;1f"
               "PID  Type Graph      CPU%% Name\x1b[K\n"
               "---- ---- ---------- ---- ----------\x1b[K\n");

        for(int i = 0; i < NUM_LINES;i++)
        {
            static char cStr[2048];

            if(i < pcList.Count())
            {
                pcList.Print(i, cStr);
                volatile int j = pcList.CPULoad(i);
                printf("\x1b[%sm%s\x1b[K\n", pcProcColor[(j*NUM_COLORS)/100], cStr);
            }
            else
                printf("\x1b[40m\x1b[0;37m\x1b[K\n");
        }
        DosSleep(INTERVAL * 1000);
    }
}

