/*
** Module   :PSCOLL.H
** Abstract :Process collection
**
** Copyright (C) Sergey I. Yevtushenko
** Log: Sun  01/06/97   Updated
*/

#ifndef  __COLLECT_H
#include <collect.h>
#endif

#ifndef  __PSCOLL_H
#define  __PSCOLL_H


struct ProcInfo
{
    int iPid;
    int iSid;
    int iType;
    int iTouched;
    int lOldUser;
    int lDeltaUser;
    int lOldSystem;
    int lDeltaSystem;
    int iUsage;

    char cProxName[265];
};

typedef ProcInfo* PInfo;

class ProcessCollection:public SortedCollection
{
        ProcInfo * CheckAndInsert(ProcInfo *, int&);
        ProcInfo * ProcessCollection::LocatePID(int pid);
        unsigned long ulTotalUsr;
        unsigned long ulTotalSys;

    public:
        ProcessCollection() {}
        ~ProcessCollection(){}

        void Print(int i, char* cStr);
        int  Pid(int i);
        int  CPULoad(int i);
        void CollectData();
        virtual int Compare(Ptr p1,Ptr p2) {return PInfo(p1)->iPid - PInfo(p2)->iPid;}
};

#endif //__PSCOLL_H

